﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class Ball : MonoBehaviour {

    static public int Count = 0;

    public Vector3 BasePosition = Vector3.zero;
    public Rigidbody Rigidbody = null;
    public Renderer Renderer = null;

    public InputAction resetButton;

    public List<Color> Colors = new List<Color>();
    public int CurrentColor = -1;

    public float respawnTimer = 0.0f;
    public float respawnSpeed = 10.0f;
    public Transform respawnDirection = null;
    public bool respawn = false;

    public static int MAX = 8;

    public static bool paused = false;

    public AudioSource AudioHit = null;

    private void Awake()
    {
        ++Count;
    }

    public void Delete()
    {
        BallManager.Instance.Balls.Remove(this);
        --Count;
        Destroy(gameObject);
    }

    // Use this for initialization
    void Start () {
        BasePosition = transform.position;
        SetRandomColor();

        BallManager.Instance.Balls.Add(this);
    }

    //private void OnCollisionEnter(Collision collision)
    //{
    //    AudioHit.Play();
    //}

    // Update is called once per frame
    void Update ()
    {
        //paused = false;

        //if (InputAdapter.Instance.IsActionActive(resetButton))
        //{
        //    paused = true;
        //}

        if (paused)
        {
            if (!Rigidbody.isKinematic) Rigidbody.isKinematic = true;
            return;
        }

        if (Rigidbody.isKinematic) Rigidbody.isKinematic = false;
        
        //if (InputAdapter.Instance.IsActionActive(resetButton))
        //{
        //    transform.position = BasePosition;
        //    Rigidbody.velocity = Vector3.zero;
        //}

        if (respawn)
        {
            respawnTimer -= Time.deltaTime;
            if (respawnTimer < 0.0f)
            {
                SetRandomColor();
                transform.position = respawnDirection.position;
                Rigidbody.velocity = respawnDirection.transform.forward * respawnSpeed;
                respawn = false;
            }
        }
	}

    public void SetRandomColor()
    {
        int random = -1;

        do
        {
            random = Random.Range(0, Colors.Count - 1);
        }
        while (random == CurrentColor);

        CurrentColor = random;

        Renderer.material.SetColor("_Color", Colors[random]);
    }

    static public void ResetCount()
    {
        Count = 0;
    }
}
