﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class Chwytak : MonoBehaviour
{
    public float openRotation = 0.0f;
    public float closedRotation = 0.0f;

    public bool open = true;
    public float totalTime = 3.0f;
    public float time = 0.0f;

    public Transform indicator = null;
    public float openPosition = 0.0f;
    public float closedPosition = 0.0f;

    public Transform waterLevel = null;
    public float openScale = 0.0f;
    public float closedScale = 0.0f;

    public float baseScale = 0.0f;

    public float waterLevelChangeSpeed = 1.0f;

    void Update ()
    {
        float targetWaterLevelScale = ((((float)Ball.Count / (float)Ball.MAX)) * openScale - baseScale) + baseScale;

        if(targetWaterLevelScale > openScale)
        {
            open = false;
        }
        else
        {
            open = true;
        }

        if (waterLevel.localScale.y < openScale)
        {            
            if (Ball.Count >= Ball.MAX)
            {
                targetWaterLevelScale = openScale;
            }

            if (waterLevel.localScale.y > targetWaterLevelScale)
            {
                float sss = waterLevel.localScale.y - (Time.deltaTime * waterLevelChangeSpeed);

                if (sss < targetWaterLevelScale) sss = targetWaterLevelScale;

                waterLevel.transform.localScale = new Vector3(waterLevel.transform.localScale.x, sss, waterLevel.transform.localScale.z);
            }
            else if (waterLevel.localScale.y < targetWaterLevelScale)
            {
                float sss = waterLevel.localScale.y + (Time.deltaTime * waterLevelChangeSpeed);

                if (sss > targetWaterLevelScale) sss = targetWaterLevelScale;

                waterLevel.transform.localScale = new Vector3(waterLevel.transform.localScale.x, sss, waterLevel.transform.localScale.z);
            }
        }
        else
        {
            if (open)
            {
                time += Time.deltaTime;
                if (time > totalTime) time = totalTime;
            }
            else
            {
                time -= Time.deltaTime;
                if (time < 0.0f) time = 0.0f;
            }

            var v = Mathf.Sin((time / totalTime) * Mathf.PI * 0.5f);
            var r = ((v * (openRotation - closedRotation)) + closedRotation);
            var p = ((v * (openPosition - closedPosition)) + closedPosition);
            var s = ((v * (openScale - closedScale)) + closedScale);

            transform.rotation = Quaternion.Euler(0.0f, 0.0f, r);
            indicator.transform.position = new Vector3(indicator.transform.position.x, p, indicator.transform.position.z);
            waterLevel.transform.localScale = new Vector3(waterLevel.transform.localScale.x, s, waterLevel.transform.localScale.z);
        }
    }
}
