﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class ClockworkAudio : MonoBehaviour

{
    public Rigidbody Rigidbody = null;
    public AudioSource AudioSource = null;

    public float speedFactor = 1.0f;

    public float maxSpeed = 10.0f;
    public float minimumTargetTime = 0.25f;

    //public float minSpeed = 10.0f;

    // Use this for initialization

    public float elapsedTime = 0.0f;
    public float targetTime = 0.0f;

    public float angularVelocity = 0.0f;

    void Start () {
		
	}
	
	// Update is called once per frame
	void Update ()
    {
        angularVelocity = Rigidbody.angularVelocity.magnitude;
        var v = angularVelocity;

        v = Mathf.Min(v, maxSpeed)/maxSpeed;
        if(v > 0.0f)
        {
            var volume = 0.0f;

            if(v > 0.5f)
            {
                volume = 1.0f;
            }
            else
            {
                volume = v / 0.5f;
            }

            AudioSource.volume = volume;

            v = 1.0f - v;

            targetTime = v * speedFactor;

            if (targetTime < minimumTargetTime) targetTime = minimumTargetTime;

            elapsedTime += Time.deltaTime;
            if(elapsedTime >= targetTime)
            {
                if(!AudioSource.isPlaying)
                {
                    AudioSource.Play();
                }
                
                elapsedTime = 0.0f;
            }
        }        
    }
}
