﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public enum EScreenConfig
{
	SingleScreen,
	DoubleScreen,
};

public delegate void ScreenConfigDelegate(EScreenConfig new_config);
public class AppSettings : MonoBehaviour
{

	public static AppSettings Instance;

	void Awake()
	{
		if (Instance == null)
			Instance = this;
		else
			Debug.LogError("Multiple AppSettings instances detected in the scene!");
	}

	public event ScreenConfigDelegate OnScreenConfigChanged;
	public EScreenConfig ScreenConfig
	{
		get
		{
			return (EScreenConfig)PlayerPrefs.GetInt("ScreenConfig");
		}

		set
		{
			PlayerPrefs.SetInt("ScreenConfig", (int)value);
			if (OnScreenConfigChanged != null)
				OnScreenConfigChanged(value);
		}
	}
}
