﻿using System;
using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class CameraDisplayChanger : MonoBehaviour
{
	private Camera ControlledCamera = null;
	public Canvas ControlledCanvas = null;
	void Awake()
	{
		if (ControlledCamera == null)
			ControlledCamera = GetComponent<Camera>();

		if(ControlledCanvas == null)
			ControlledCanvas = GetComponent<Canvas>();

		if(ControlledCamera == null && ControlledCanvas == null)
		{
			this.enabled = false;
		}
	}

	void Start()
	{
		AppSettings.Instance.OnScreenConfigChanged += new ScreenConfigDelegate(this.OnScreenConfigChanged);
		OnScreenConfigChanged(AppSettings.Instance.ScreenConfig);
	}

	private void OnScreenConfigChanged(EScreenConfig new_config)
	{
		if(ControlledCamera != null)
			ControlledCamera.targetDisplay = (int)new_config;
		if(ControlledCanvas != null)
			ControlledCanvas.targetDisplay = (int)new_config;
	}
}
