﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class Flipper : MonoBehaviour
{
    public HingeJoint HingeJoint = null;
    public float restPosition = 0.0f;
    public float pressedPosition = 45.0f;
    public float hitStrength = 1000.0f;
    public float flipperDamper = 150.0f;

    public List<InputAction> buttons;

    public AudioSource AudioUp = null;
    public AudioSource AudioDown = null;

    public bool prevPressed = false;

    void Update()
    {
        JointSpring jointSpring = new JointSpring();
        jointSpring.spring = hitStrength;
        jointSpring.damper = flipperDamper;


        bool pressed = false;

        if (!Ball.paused)
        {
            foreach (var button in buttons)
            {
                if (InputAdapter.Instance.IsActionActive(button))
                {
                    pressed = true;
                    break;
                }
            }
        }

        if(pressed && !prevPressed)
        {
            AudioUp.Play();
        }
        else if(!pressed && prevPressed)
        {
            AudioDown.Play();
        }

        if (pressed)
        {
            jointSpring.targetPosition = pressedPosition;
        }
        else
        {
            jointSpring.targetPosition = restPosition;
        }

        prevPressed = pressed;

        HingeJoint.spring = jointSpring;
        HingeJoint.useSpring = true;
    }
}
