﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class MovingMech : MonoBehaviour {

    public Transform TargetTransform = null;

    Vector3 startPosition = Vector3.zero;
    Vector3 targetPosition = Vector3.zero;
    Vector3 diff = Vector3.zero;

    public float speed = 1.5f;
    public float timeOffset = 0.0f;

    float time = 0.0f;

    // Use this for initialization
    void Start () {
        startPosition = transform.position;
        targetPosition = TargetTransform.position;

        diff = targetPosition - startPosition;

    }
	
	// Update is called once per frame
	void Update () {

        

        float value = (Mathf.Sin((time * speed) + timeOffset) + 1.0f) * 0.5f;

        transform.position = startPosition + (value * diff);


    }

    public void Tick(float deltaTime)
    {
        time += deltaTime;
    }
}
