﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class TickScript : MonoBehaviour {

    public GameObject TickLayer;

    public delegate void EnabledSignal(bool enabled);
    public EnabledSignal OnEnableChanged;

    public bool Enabled = true;

    public void OnTick()
    {
        if (TickLayer.activeInHierarchy)
        {
            TickLayer.SetActive(false);
            Enabled = false;
        }
        else
        {
            TickLayer.SetActive(true);
            Enabled = true;
        }

        if (OnEnableChanged != null)
        {
            OnEnableChanged(Enabled);
        }
    }

	// Use this for initialization
	void Start () {
		if (Enabled)
        {
            TickLayer.SetActive(true);
        }
        else
        {
            TickLayer.SetActive(false);
        }
	}
	
	// Update is called once per frame
	void Update () {
		
	}
}
